package com.gmh.service.impl;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gmh.dao.SysBaijiaxingDao;
import com.gmh.entity.SysBaijiaxing;
import com.gmh.service.SysBaijiaxingService;
import com.gmh.utils.RedisUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

@Service
@Slf4j
public class SysBaijiaxingServiceImpl extends ServiceImpl<SysBaijiaxingDao, SysBaijiaxing> implements SysBaijiaxingService, InitializingBean {

    @Autowired
    private RedisUtils redisUtils;

    @Override
    public boolean likeChineseName(String val) {
        if (StrUtil.isBlank(val)) {
            return false;
        }
        String first = val.substring(0, 1);
        Collection<String> keys = redisUtils.keys(KEY_XINGSHI + first + "*");
        return keys.size() > 0;
//        QueryWrapper<SysBaijiaxing> queryWrapper = new QueryWrapper<>();
//        queryWrapper.apply("{0} LIKE CONCAT(xingshi,'%')", val);
//        List<SysBaijiaxing> list = list(queryWrapper);
//        return !list.isEmpty();
    }

    private static final String KEY_XINGSHI = "cache_xingshi:";

    @Override
    public void afterPropertiesSet() {
        log.info("Initializing baijiaxing cache ....");
        List<SysBaijiaxing> list = list();
        Set<String> collect = list.stream().map(SysBaijiaxing::getXingshi).collect(Collectors.toSet());
        for (String xingshi : collect) {
            redisUtils.setCacheObject(KEY_XINGSHI + xingshi, xingshi);
        }
        log.info("baijiaxing cache loading completed!");
    }
}
